

import java.awt.*;
import javax.swing.*;

import java.util.*;


public class Sprite
{

   /*
    * This maintains a database of all of the sprites
    */

   private static LinkedList<Sprite> allOfThem = new LinkedList<Sprite>();


   private static void rememberThisSprite(Sprite sprite)
   {
      allOfThem.add(sprite);
      sprite.speedX =
      sprite.speedY = 0;
   }


   public static void MoveSprites(double time)
   {
      for(Sprite s : allOfThem)
      {
         s.x += (int)(s.speedX * time);
         s.y += (int)(s.speedY * time);
      }
   }


   /*
    * This maintains a database of all of the sprites
    */

   protected Image   image;

   protected int     width;
   protected int     height;

   protected int     x;
   protected int     y;

   protected boolean visible;

   protected double  speedX;   // speed measured in pixels per millisecond
   protected double  speedY;


   /*
    * Constructors
    */

   public Sprite(String filename)
   {
      rememberThisSprite(this);

      image  = (new ImageIcon(filename)).getImage();

      width  = image.getWidth(null);
      height = image.getHeight(null);

      //System.out.println(filename);
      //System.out.println("width = " + width);
      //System.out.println("height = " + height);

      x =
      y = 0;

      visible = false;
   }


   public Sprite(String filename, int x, int y)
   {
      this(filename);
      this.x = x;
      this.y = y;
   }


   public Sprite(String filename, int x, int y, boolean visible)
   {
      this(filename, x, y);
      this.visible = visible;
   }


   /*
    * Accessors and Mutators
    */

   public Image getImage()
   {
      return image;
   }

   public int getWidth()
   {
      return width;
   }

   public int getHeight()
   {
      return height;
   }

   public void setXY(int x, int y)
   {
      this.x = x;
      this.y = y;
   }

   public int getX()
   {
      return x;
   }

   public int getY()
   {
      return y;
   }

   public void setVisible(boolean visible)
   {
      this.visible = visible;
   }

   public boolean isVisible()
   {
      return visible;
   }

   public void setSpeedX(double speedX)
   {
      this.speedX = speedX;
   }

   public void setSpeedY(double speedY)
   {
      this.speedY = speedY;
   }

   public void setSpeedXY(double speedX, double speedY)
   {
      this.speedX = speedX;
      this.speedY = speedY;
   }
}




